#
# Conditional build:
%bcond_without	python2 # CPython 2.x module
%bcond_without	python3 # CPython 3.x module
%bcond_without	doc	# API documentation
%bcond_without	tests	# unit tests

Summary:	Clean single-source support for Python 3 and 2
Summary(pl.UTF-8):	Czysta obsługa Pythona 3 i 2 w jednych źródłach
Name:		python-future
Version:	0.18.2
Release:	7
License:	MIT
Group:		Libraries/Python
#Source0Download: https://pypi.org/simple/future/
Source0:	https://files.pythonhosted.org/packages/source/f/future/future-%{version}.tar.gz
# Source0-md5:	e4579c836b9c025872efe230f6270349
Patch0:		%{name}-tests.patch
URL:		https://python-future.org/
%if %{with python2}
BuildRequires:	python-modules >= 1:2.6
BuildRequires:	python-setuptools
%if "%{py_ver}" < "2.7"
BuildRequires:	python-argparse
BuildRequires:	python-importlib
%if %{with tests}
BuildRequires:	python-2to3
BuildRequires:	python-unittest2
%endif
%endif
%endif
%if %{with python3}
BuildRequires:	python3-modules >= 1:3.3
BuildRequires:	python3-setuptools
%endif
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.714
%if %{with doc}
BuildRequires:	python3-sphinx_bootstrap_theme
BuildRequires:	sphinx-pdg-3
%endif
Requires:	python-modules >= 1:2.6
%if "%{py_ver}" < "2.7"
Requires:	python-argparse
Requires:	python-importlib
Requires:	python-unittest2
%endif
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
future is the missing compatibility layer between Python 2 and
Python 3.  It allows you to use a single, clean Python 3.x-compatible
codebase to support both Python 2 and Python 3 with minimal overhead.

%description -l pl.UTF-8
future to brakująca warstwa zgodności między Pythonem 2 i 3. Pozwala
na używanie pojedynczego kodu źródłowego w Pythonie 3.x do obsługi
zarówno Pythona 2, jak i 3 z minimalnym narzutem.

%package -n python3-future
Summary:	Clean single-source support for Python 3 and 2
Summary(pl.UTF-8):	Czysta obsługa Pythona 3 i 2 w jednych źródłach
Group:		Libraries/Python
Requires:	python3-modules >= 1:3.3

%description -n python3-future
future is the missing compatibility layer between Python 2 and
Python 3.  It allows you to use a single, clean Python 3.x-compatible
codebase to support both Python 2 and Python 3 with minimal overhead.

%description -n python3-future -l pl.UTF-8
future to brakująca warstwa zgodności między Pythonem 2 i 3. Pozwala
na używanie pojedynczego kodu źródłowego w Pythonie 3.x do obsługi
zarówno Pythona 2, jak i 3 z minimalnym narzutem.

%package apidocs
Summary:	API documentation for Python future module
Summary(pl.UTF-8):	Dokumentacja API modułu Pythona future
Group:		Documentation

%description apidocs
API documentation for Python future module.

%description apidocs -l pl.UTF-8
Dokumentacja API modułu Pythona future.

%prep
%setup -q -n future-%{version}
%patch -P 0 -p1

%build
%if %{with python2}
%py_build

%if %{with tests}
PYTHONPATH=$(pwd)/build-2/lib \
%{__python} -m unittest discover -s tests
%endif
%endif

%if %{with python3}
%py3_build

%if %{with tests}
# FIXME: fail with py3.9(?) as of future-0.18.2
%{__rm} tests/test_future/test_standard_library.py \
	tests/test_future/test_urllib_toplevel.py \
	tests/test_past/test_translation.py

PYTHONPATH=$(pwd)/build-3/lib \
%{__python3} -m unittest discover -s tests
%endif
%endif

%if %{with doc}
PYTHONPATH=$(pwd)/build-3/lib \
%{__make} -C docs html \
	SPHINXBUILD=sphinx-build-3
%endif

%install
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%py_install

%py_postclean

%{__mv} $RPM_BUILD_ROOT%{_bindir}/futurize{,-2}
%{__mv} $RPM_BUILD_ROOT%{_bindir}/pasteurize{,-2}
%endif

%if %{with python3}
%py3_install

%{__mv} $RPM_BUILD_ROOT%{_bindir}/futurize{,-3}
%{__mv} $RPM_BUILD_ROOT%{_bindir}/pasteurize{,-3}

ln -sf futurize-3 $RPM_BUILD_ROOT%{_bindir}/futurize
ln -sf pasteurize-3 $RPM_BUILD_ROOT%{_bindir}/pasteurize
%endif

%clean
rm -rf $RPM_BUILD_ROOT

%if %{with python2}
%files
%defattr(644,root,root,755)
%doc LICENSE.txt README.rst
%attr(755,root,root) %{_bindir}/futurize-2
%attr(755,root,root) %{_bindir}/pasteurize-2
%{py_sitescriptdir}/_dummy_thread
%{py_sitescriptdir}/_markupbase
%{py_sitescriptdir}/_thread
%{py_sitescriptdir}/builtins
%{py_sitescriptdir}/copyreg
%{py_sitescriptdir}/future
%{py_sitescriptdir}/html
%{py_sitescriptdir}/http
%{py_sitescriptdir}/libfuturize
%{py_sitescriptdir}/libpasteurize
%{py_sitescriptdir}/past
%{py_sitescriptdir}/queue
%{py_sitescriptdir}/reprlib
%{py_sitescriptdir}/socketserver
%{py_sitescriptdir}/tkinter
%{py_sitescriptdir}/winreg
%{py_sitescriptdir}/xmlrpc
%{py_sitescriptdir}/future-%{version}-py*.egg-info
%endif

%if %{with python3}
%files -n python3-future
%defattr(644,root,root,755)
%doc LICENSE.txt README.rst
%attr(755,root,root) %{_bindir}/futurize
%attr(755,root,root) %{_bindir}/futurize-3
%attr(755,root,root) %{_bindir}/pasteurize
%attr(755,root,root) %{_bindir}/pasteurize-3
%{py3_sitescriptdir}/future
%{py3_sitescriptdir}/libfuturize
%{py3_sitescriptdir}/libpasteurize
%{py3_sitescriptdir}/past
%{py3_sitescriptdir}/future-%{version}-py*.egg-info
%endif

%if %{with doc}
%files apidocs
%defattr(644,root,root,755)
%doc docs/build/html/{_modules,_static,*.html,*.js}
%endif
%changelog
* Thu May 08 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/python-future.git;a=log;h=auto/th/python-future-0.18.2-7

* Tue Mar 11 2025 Jan Rękorajski <baggins@pld-linux.org> d194d31
- doc/test rebuild for python 3.13

* Mon Mar 10 2025 Jan Rękorajski <baggins@pld-linux.org> ef3eba5
- python 3.13 rebuild

* Sun Mar 09 2025 Jan Rękorajski <baggins@pld-linux.org> 448c7b5
- use patch -P

* Wed Mar 30 2022 Jan Rękorajski <baggins@pld-linux.org> f961603
- rebuild with tests and docs

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> 0379646
- rebuild with python 3.10

* Fri Mar 25 2022 Jan Rękorajski <baggins@pld-linux.org> bb3c46d
- rebuild with python 3.10

* Mon Mar 14 2022 Jakub Bogusz <qboosh@pld-linux.org> 5a09ca9
- disabled more python3 tests

* Sat Feb 27 2021 Jan Rękorajski <baggins@pld-linux.org> 9f00584
- release 2 (by relup.sh)

* Thu Dec 12 2019 Marcin Krol <hawk@tld-linux.org> 32cf626
- updated to 0.18.2

* Mon Oct 28 2019 Jan Rękorajski <baggins@pld-linux.org> 7ba6db9
- rebuild with python 3.8
- release 2 (by relup.sh)

* Sun Oct 06 2019 Jakub Bogusz <qboosh@pld-linux.org> e21c159
- updated to 0.17.1

* Sun Oct 06 2019 Jakub Bogusz <qboosh@pld-linux.org> 8f33d0a
- updated to 0.17.0
- updated tests patch
- removed obsolete py37,div patches

* Fri Sep 21 2018 Jakub Bogusz <qboosh@pld-linux.org> d03e8fe
- added py37 and div patches from git
- added tests patch (skip network based tests)
- disable one more tests set on python3 (fails with python 3.7)
- added -apidocs

* Wed Sep 12 2018 Jan Palus <atler@pld-linux.org> e26a66f
- switch to reusable source url

* Tue Sep 11 2018 Jan Palus <atler@pld-linux.org> 8821ece
- new (version 0.16.0)

